// pip.cpp		ver.0.00
//copyright 2006 Beer[Tsutsumi Hiroyuki]

#include	"pip.h"

#define	VER		"ver.0.00"
#define	DATE	"2006. 5.20"

int main(int argc,char **argv)
{
	if(!(tr=BTranslatorRoster::Default()))return(1);
	pip	app(argc,argv);
	app.Run();
	return(0);
}
//------------------------------------------------
pip::pip(int argc,char **argv):BApplication("application/x-vnd.Beer-pip")
{
#if	B_BEOS_VERSION>=0x0520
	app_info	ai;	be_app->GetAppInfo(&ai);
	BPath	ap(&ai.ref),dp;
	ap.GetParent(&dp);
	BPath	lp(dp);
	lp.Append("Language/Dictionaries");
	lp.Append("pip");
	be_locale.LoadLanguageFile(lp.Path());
#endif

	BRect	frame(100,100,300,250);
	w=new pipwindow(frame);
	if(argc>1){
		BMessage msg(B_SIMPLE_DATA);
		for(int i=1;i<argc;i++){
			BEntry	e(argv[i]);
			entry_ref	eref;
			e.GetRef(&eref);
			msg.AddRef("refs",&eref);
		}
		BMessenger(w->v).SendMessage(&msg);//w->PostMessage(&msg,w->v);
	}
}

void pip::RefsReceived(BMessage *mes)
{
	uint32	type;
	int32	files;
	mes->GetInfo("refs",&type,&files);
	if(files>0){
		entry_ref	eref;
		BMessage msg(B_SIMPLE_DATA);
		for(int i=0;i<files;i++){
			mes->FindRef("refs",i,&eref);
			msg.AddRef("refs",&eref);
		}
		BMessenger(w->v).SendMessage(&msg);//w->PostMessage(&msg,w->v);
	}
}

void pip::MessageReceived(BMessage *mes)
{
	switch(mes->what){
		case B_SAVE_REQUESTED:{
			entry_ref	dir;
			const char		*name;
			mes->FindRef("directory",&dir);
			mes->FindString("name",&name);
			BMessage msg(B_SAVE_REQUESTED);
			msg.AddRef("directory",&dir);
			msg.AddString("name",name);
			BMessenger(w->v).SendMessage(&msg);//w->PostMessage(&msg,w->v);
		}break;
		case B_CANCEL:{
			BMessenger(w->v).SendMessage(B_CANCEL);//w->PostMessage(B_CANCEL,w->v);
		}break;
		default:{
			BApplication::MessageReceived(mes);
		}break;
	}
}

void pip::AboutRequested()
{ 
	BAlert *alert;
	alert=new BAlert("",
		"pip "VER"   "DATE"\n"
		"    copyright Hiroyuki Tsutsumi\n\n"
		" E-mail : gch07232@nifty.ne.jp\n"
		"   HP   : http://www.eonet.ne.jp/~hirotsu/"
	,"Thank you");
	alert->Go();
} 
//------------------------------------------------
pipwindow::pipwindow(BRect frame):BWindow(frame,"pip "VER,B_DOCUMENT_WINDOW,0)
{
	sbv=sbh=NULL;
	BRect	viewframe;
	viewframe.Set(0,0,frame.Width()-B_V_SCROLL_BAR_WIDTH,frame.Height()-B_H_SCROLL_BAR_HEIGHT-20);
	viewframe.OffsetTo(0,20);
	v=new pipview(viewframe);
	AddChild(v);
	setupmenus();
	BRect	sbvframe;
	sbvframe.Set(0,0,B_V_SCROLL_BAR_WIDTH,viewframe.Height()+2);
	sbvframe.OffsetTo(viewframe.Width()+1,20-1);
	sbv=new BScrollBar(sbvframe,"scrollv",(BView*)v,0,0,B_VERTICAL);
	AddChild(sbv);
	BRect	sbhframe;
	sbhframe.Set(0,0,viewframe.Width()+2,B_H_SCROLL_BAR_HEIGHT);
	sbhframe.OffsetTo(-1,viewframe.Height()+21);
	sbh=new BScrollBar(sbhframe,"scrollh",(BView*)v,0,0,B_HORIZONTAL);
	AddChild(sbh);
	FrameResized(frame.Width(),frame.Height());
	resizeview(0,0);
	Show();
	SetPulseRate(100000);
}

bool pipwindow::QuitRequested()
{
	BMessenger(be_app).SendMessage(B_QUIT_REQUESTED);//be_app->PostMessage(B_QUIT_REQUESTED);
	return(true);
}

void pipwindow::FrameResized(float width,float height)
{
	float	rv,rh;
	rv=pic.Height()-sbv->Bounds().Height()+2;
	rh=pic.Width()-sbh->Bounds().Width()+2;
	sbv->SetRange(0,rv>0?rv:0);
	sbh->SetRange(0,rh>0?rh:0);
	sbv->SetProportion(sbv->Bounds().Height()/pic.Height());
	sbh->SetProportion(sbh->Bounds().Width()/pic.Width());
	sbv->SetSteps(10,sbv->Bounds().Height());
	sbh->SetSteps(10,sbh->Bounds().Width());
}

void pipwindow::resizeview(int width,int height)
{
	if(width==0)width=200-B_V_SCROLL_BAR_WIDTH;
	if(height==0)height=150-B_H_SCROLL_BAR_HEIGHT-20;
	int	ww,hh;
	ww=width+B_V_SCROLL_BAR_WIDTH;
	hh=height+B_H_SCROLL_BAR_HEIGHT+20;
	SetSizeLimits(35,ww,35,hh);
	SetZoomLimits(ww,hh);
	ResizeTo(ww,hh);
	v->ResizeTo(width,height);
}

void pipwindow::setupmenus()
{
	BMenuBar	*mb;
	BMenu		*m,*mm;
	BMenuItem	*mi;
	BMessage	*mes;
	mb=new BMenuBar(BRect(0,0,20,20),"menubar");
	m=new BMenu(_T("File"));
	 mi=new BMenuItem(_T("Open"),new BMessage('fiop'));
	 mi->SetTarget((BHandler*)v);
	 m->AddItem(mi);
	 mi=new BMenuItem(_T("About"),new BMessage(B_ABOUT_REQUESTED));
	 mi->SetTarget((BHandler*)be_app);
	 m->AddItem(mi);
	 mi=new BMenuItem(_T("Quit"),new BMessage(B_QUIT_REQUESTED));
	 mi->SetTarget((BHandler*)be_app);
	 m->AddItem(mi);
	mb->AddItem(m);
	AddChild(mb);
}
//------------------------------------------------
pipview::pipview(BRect frame):BView(frame,"pipview",B_FOLLOW_ALL_SIDES,B_WILL_DRAW|B_PULSE_NEEDED)
{
	bm=NULL;	bm_pce=NULL;	bm_brd=NULL;
	fp=NULL;
	mf=0;
	df=false;
	strcpy(title,"pip "VER);
}

pipview::~pipview()
{
	if(bm)delete bm;
	if(bm_brd)delete bm_brd;
	if(bm_pce)delete bm_pce;
}

void pipview::AttachedToWindow()
{
	SetHighColor(255,255,255);
	SetViewColor(0,0,0);
	SetLowColor(100,100,100);
	SetFont(be_bold_font);
}

void pipview::Draw(BRect rect)
{
	if(bm){
		DrawBitmap(bm,rect,rect);
		if(pl.CountItems()){
			piece	*pce=(piece*)pl.ItemAt(no);
			DrawBitmap(pce->bm,pce->p);
		}else{
			DrawString("complete",BPoint(20,20));
		}
	}
	if(!bm){
		SetFontSize(30);
		DrawString("pip",BPoint(45,50));
		SetFontSize(20);
		DrawString(VER,BPoint(75,80));
	}
}

void pipview::Pulse()
{
}

void pipview::MouseDown(BPoint pt)
{
	SetMouseEventMask(B_POINTER_EVENTS);
	if(!pic.Contains(pt))return;
	
	int32	mt;					get_mouse_type(&mt);
	uint32	mk;					mk=modifiers();
	BPoint	mp;	uint32	mb;		GetMouse(&mp,&mb);
	mf=(uchar)mb;
	if(mf==B_PRIMARY_MOUSE_BUTTON){
		if(mk&B_SHIFT_KEY)mf=B_SECONDARY_MOUSE_BUTTON;
		if(mk&B_CONTROL_KEY)mf=B_TERTIARY_MOUSE_BUTTON;
	}

	if(pl.CountItems()==0)return;
	piece	*pce=(piece*)pl.ItemAt(no);
	BRect	pr(pce->rec);
	int	f=0;
	if(pr.Contains(pt)){	//piece
		if(pget(pce->bm,pt)&0xff000000){
			df=true;	dpt=pt;
			BMessage	*mes=new BMessage('none');
			BBitmap	*bmdd=new BBitmap(pce->bm);
			DragMessage(mes,bmdd,B_OP_ALPHA,BPoint(pt.x,pt.y));
			f=1;
		}
	}else{					//place
		uint32	c=pget(bm_pce,pt)&0xffffff;
		if(c==pce->col)hit();
		if(c!=bgcol)f=2;
	}
	if(f==0){
		if(mf==B_PRIMARY_MOUSE_BUTTON)change(-1);	//next
		if(mf==B_SECONDARY_MOUSE_BUTTON)change(-2);	//back
	}
}

void pipview::MouseUp(BPoint pt)
{
	if(!df)return;
	df=false;
	if(pl.CountItems()==0)return;
	piece	*pce=(piece*)pl.ItemAt(no);
	pt-=dpt;
	int	dx=pce->o.x-pt.x;
	int	dy=pce->o.y-pt.y;
	if((dx<-9)||(dx>9)||(dy<-9)||(dy>9))return;
	hit();
}

void pipview::MouseMoved(BPoint pt,uint32 code,const BMessage *msg)
{
}

void pipview::MessageReceived(BMessage *msg)
{
//msg->PrintToStream();
	static BPoint	dp;
	BPoint	dr_pt,dr_off;
	if((!msg->FindPoint("_drop_point_",&dr_pt))&&(!msg->FindPoint("_drop_offset_",&dr_off))){
		ConvertFromScreen(&dr_pt);
		float	sc;
		if(!msg->FindFloat("scale",&sc))dr_off=BPoint(dr_off.x/sc,dr_off.y/sc);	//for gprop
		dp=dr_pt-dr_off;
	}

	switch(msg->what){
		case B_SIMPLE_DATA:{	//'DATA'(drop from external)
			uint32	type;
			int32	files;
			if(!msg->GetInfo("refs",&type,&files)){		//file
				for(int i=0;i<files;i++){
					entry_ref	eref;
					msg->FindRef("refs",i,&eref);
					init();
					load(eref);
					if(bm)break;
				}
				redraw();
			}
		}break;
		case 'fiop':{
			if(fp==NULL){
				fp=new BFilePanel(B_OPEN_PANEL,NULL,NULL,B_FILE_NODE,false);
				fp->Show();
			}
		}break;
		default:{
			BView::MessageReceived(msg);
		}break;
	}
}

void pipview::redraw(bool rf)
{
	if(bm){
		SetViewColor(B_TRANSPARENT_32_BIT);
		pic=bm->Bounds();
		if(rf)((pipwindow*)Window())->resizeview(pic.Width(),pic.Height());
/*
		char	s[64];
		sprintf(s,"%s[%dx%d]",title,pic.IntegerWidth()+1,pic.IntegerHeight()+1);
		Window()->SetTitle(s);
*/
		Window()->SetTitle(title);
		Draw(Bounds());
	}else{
		Hide();
		SetViewColor(0,0,0);
		pic=BRect(-1,-1,-1,-1);
		if(rf)((pipwindow*)Window())->resizeview(0,0);
		Window()->SetTitle("pip "VER);
		Show();
	}
}

void pipview::init()
{
//delete all
	for(int i=0;i<pl.CountItems();i++){
		piece	*pce=(piece*)pl.ItemAt(i);
		delete pce;
	}
	pl.MakeEmpty();
	if(bm){delete bm;bm=NULL;}
//random
	struct timeval	tv;
	struct timezone	tz;
	gettimeofday(&tv,&tz);
//printf("clock=%ld:%ld\n",tv.tv_sec,tv.tv_usec);
	srand(tv.tv_sec|tv.tv_usec);
}

void pipview::load(entry_ref &eref)
{
	char	brdfn[64],pcefn[64],path[256];
	int		stt=0;
	BFile	*rf=new BFile(&eref,B_READ_ONLY);
	char	*buf=new char[0x1000];
	char	*be=buf+rf->Read(buf,0x1000);
	char	*bp=buf;
	if(!strncmp(buf,"pip",3)){
		while(bp<be){
			if(*(bp++)!=0x0a)continue;
			if(!strncmp(bp,"end",3))break;
			if(!strncmp(bp,"title",5))sscanf(bp+5,"%s",title);
			if(!strncmp(bp,"board",5))sscanf(bp+5,"%s",brdfn);
			if(!strncmp(bp,"piece",5))sscanf(bp+5,"%s",pcefn);
			if(!strncmp(bp,"bgcol",5))sscanf(bp+5,"%x",&bgcol);
			if(!strncmp(bp,"bdcol",5))sscanf(bp+5,"%x",&bdcol);
		}
	}else{
		stt=1;
	}
printf("title=[%s]\n",title);
printf("board=[%s]\n",brdfn);
printf("piece=[%s]\n",pcefn);
printf("bgcol=[%08x]\n",bgcol);
printf("bdcol=[%08x]\n",bdcol);
	delete rf;
	delete buf;
	if(stt)return;

	BPath	dpt(&eref);
printf("path=[%s]\n",dpt.Path());
	dpt.GetParent(&dpt);
printf("dirpath=[%s]\n",dpt.Path());
//	dpt.SetTo(dpt.Path(),board);
//printf("path=[%s]\n",dpt.Path());

//read piece_pic
	sprintf(path,"%s/%s",dpt.Path(),pcefn);
printf("piece=[%s]\n",path);
	loadpic(path,bm_pce);
//read board_pic
	sprintf(path,"%s/%s",dpt.Path(),brdfn);
printf("board=[%s]\n",path);
	loadpic(path,bm_brd);

//create each_piece(rect)
	uint32	*p,*q,*r;
	int	w,h,pw,ph;
	p=(uint32*)bm_pce->Bits();
	w=bm_pce->Bounds().IntegerWidth()+1;
	h=bm_pce->Bounds().IntegerHeight()+1;
printf("pce : w=%d h=%d\n",w,h);
	for(int y=0;y<h;y++)for(int x=0;x<w;x++,p++){
		uint32	c=*p&0xffffff;
		if(c==bgcol)continue;
		if(c==bdcol)continue;
		for(int j=0;;j++){
			piece	*pce=(piece*)pl.ItemAt(j);
			if(pce==NULL){
				pce=new piece();
				pl.AddItem(pce);
				pce->col=c;
				pce->rec=BRect(x,y,x,y);
				pce->bm=NULL;
			}
			if(pce->col!=c)continue;
			if(pce->rec.left>x)pce->rec.left=x;
			if(pce->rec.right<x)pce->rec.right=x;
			if(pce->rec.top>y)pce->rec.top=y;
			if(pce->rec.bottom<y)pce->rec.bottom=y;
			break;
		}
	}
printf("pieces=%d\n",pl.CountItems());
//create each_piece(pic)
	for(int i=0;i<pl.CountItems();i++){
		piece	*pce=(piece*)pl.ItemAt(i);
printf("no.%d : %08x\n",i,pce->col);
		pw=pce->rec.IntegerWidth()+1;
		ph=pce->rec.IntegerHeight()+1;
		pce->bm=new BBitmap(BRect(0,0,pw-1,ph-1),B_RGB_32_BIT);
		p=(uint32*)bm_pce->Bits()+w*(int)pce->rec.top+(int)pce->rec.left;
		q=(uint32*)bm_brd->Bits()+w*(int)pce->rec.top+(int)pce->rec.left;
		r=(uint32*)pce->bm->Bits();
		for(int y=0;y<ph;y++,p+=w-pw,q+=w-pw)for(int x=0;x<pw;x++,p++,q++,r++){
			if((*p&0xffffff)==pce->col)*r=*q|0xff000000;else *r=0;
		}
		pce->p=BPoint(0,0);
		pce->o=pce->rec.LeftTop();
		pce->rec.OffsetTo(0,0);
	}
//create play_bm
	if(bm){delete bm;bm=NULL;}
	bm=new BBitmap(BRect(0,0,w-1,h-1),B_RGB_32_BIT);
	p=(uint32*)bm_pce->Bits();
	q=(uint32*)bm_brd->Bits();
	r=(uint32*)bm->Bits();
	for(int y=0;y<h;y++)for(int x=0;x<w;x++,p++,q++,r++){
		uint32	c=*p&0xffffff;
		if(c==bgcol)*r=*q;
		else if(c==bdcol)*r=0x000000;
		else *r=0xffffff;
	}

//shuffle
	for(int i=pl.CountItems();i>0;i--){
		int	j=rand()%i;
		piece	*pce=(piece*)pl.ItemAt(j);
		pl.RemoveItem(j);
		pl.AddItem(pce);
	}

	no=0;
}

void pipview::loadpic(char *fn,BBitmap *&b)
{
	if(b){delete b;b=NULL;}
	BFile	*rf=new BFile(fn,B_READ_ONLY);
	BBitmapStream	outstrm;
	if(!tr->Translate(rf,NULL,NULL,&outstrm,B_TRANSLATOR_BITMAP))outstrm.DetachBitmap(&b);
	delete	rf;
#if	BYTE_ORDER==__BIG_ENDIAN
	if(b)if((b->ColorSpace()==B_RGB32_BIG)||(b->ColorSpace()==B_RGBA32_BIG)){
		BBitmap	*tb=b;
		b=new BBitmap(tbm->Bounds(),B_RGB_32_BIT);
		uint32	*q=(uint32*)b->Bits();
		uint32	*p=(uint32*)tb->Bits();
		int	len=tb->BitsLength()/4;
		for(int i=0;i<len;i++)*(q++)=B_SWAP_INT32(*(p++));
		delete	tb;
	}
#endif
}

void pipview::savepic(char *fn,BBitmap *&b)
{
printf("savepic: [%s]\n",fn);
	BFile	*wf=new BFile(fn,B_WRITE_ONLY|B_CREATE_FILE|B_FAIL_IF_EXISTS);
	BBitmapStream	instrm(b);
	tr->Translate(&instrm,NULL,NULL,wf,'PNG ');
	instrm.DetachBitmap(&b);
	BAppFileInfo	wfi(wf);
	wfi.SetType("image/png");
	delete	wf;
}

uint32 pipview::pget(BBitmap *b,BPoint p)
{
	uint32	*o=(uint32*)b->Bits();
	int	w=b->Bounds().IntegerWidth()+1;
//	int	h=b->Bounds().IntegerHeight()+1;
	uint32	c=*(o+w*(int)p.y+(int)p.x);
	return(c);
}

void pipview::hit()
{
printf("hit\n");
//set image from pce_bm to bm
	piece	*pce=(piece*)pl.ItemAt(no);
	int	w,h,pw,ph;
	uint32	*p,*q;
	w=bm->Bounds().IntegerWidth()+1;
	h=bm->Bounds().IntegerHeight()+1;
	pw=pce->rec.IntegerWidth()+1;
	ph=pce->rec.IntegerHeight()+1;
	p=(uint32*)pce->bm->Bits();
	q=(uint32*)bm->Bits()+w*(int)pce->o.y+(int)pce->o.x;
	for(int y=0;y<ph;y++,q+=w-pw)for(int x=0;x<pw;x++,p++,q++){
		if(*p&0xff000000)*q=*p;
	}

	pl.RemoveItem(no);
	delete pce;
	if(no>=pl.CountItems())no=0;
	Invalidate();
}

void pipview::change(int n)
{
printf("change\n");
	if(n==-1)if(++no>=pl.CountItems())no=0;
	if(n==-2)if(--no<0)no=pl.CountItems()-1;
	if(n>=0)if((no=n)>=pl.CountItems())no=0;
	Invalidate();
}
//------------------------------------------------
piece::piece()
{
}

piece::~piece()
{
	if(bm)delete bm;
}
